{
    "$graph": [
        {
            "label": "bacterial_orthology",
            "class": "Workflow",
            "requirements": [
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "NetworkAccess",
                    "networkAccess": true
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "id": "#main/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/blast_hits_cache"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#main/blastdb"
                },
                {
                    "type": "File",
                    "id": "#main/gc_cache"
                },
                {
                    "type": "File",
                    "id": "#main/gc_id_list_orth"
                },
                {
                    "type": "File",
                    "id": "#main/gencoll_asn"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "int"
                    },
                    "id": "#main/genus_list"
                },
                {
                    "type": "File",
                    "id": "#main/input"
                },
                {
                    "type": "File",
                    "id": "#main/naming_sqlite"
                },
                {
                    "type": "string",
                    "id": "#main/scatter_gather_nchunks"
                },
                {
                    "type": "int",
                    "id": "#main/taxid"
                },
                {
                    "type": "File",
                    "id": "#main/taxon_db"
                }
            ],
            "steps": [
                {
                    "label": "BLASTp Current Prokaryotic Proteins vs Orthologs",
                    "run": "#tt_blastp_wnode_naming.cwl",
                    "in": [
                        {
                            "default": "subject",
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/affinity"
                        },
                        {
                            "default": "score>0 && pct_identity_gapopen_only > 35",
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/align_filter"
                        },
                        {
                            "default": true,
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/allow_intersection"
                        },
                        {
                            "source": "#main/asn_cache",
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/asn_cache"
                        },
                        {
                            "source": "#main/blast_hits_cache",
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/blast_hits_cache"
                        },
                        {
                            "default": "predicted-protein",
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/blast_type"
                        },
                        {
                            "source": [
                                "#main/blastdb"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/blastdb"
                        },
                        {
                            "source": "#main/create_orthologous_prokaryotic_protein_blastdb/blastdb",
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/blastdb_dir"
                        },
                        {
                            "default": "F",
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/comp_based_stats"
                        },
                        {
                            "default": true,
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/compart"
                        },
                        {
                            "default": "6000000000",
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/dbsize"
                        },
                        {
                            "default": 0,
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/delay"
                        },
                        {
                            "default": 0.1,
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/evalue"
                        },
                        {
                            "source": "#main/genus_list",
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/genus_list"
                        },
                        {
                            "source": [
                                "#main/extract_protein_targets_for_orthology/seqids"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/ids"
                        },
                        {
                            "source": "#main/extract_protein_targets_for_orthology/lds2",
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/lds2"
                        },
                        {
                            "default": 10000,
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/max_batch_length"
                        },
                        {
                            "default": 1,
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/max_jobs"
                        },
                        {
                            "default": 50,
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/max_target_seqs"
                        },
                        {
                            "default": false,
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/no_merge"
                        },
                        {
                            "default": true,
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/nogenbank"
                        },
                        {
                            "default": "asn-binary",
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/ofmt"
                        },
                        {
                            "source": "#main/extract_protein_targets_for_orthology/proteins",
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/proteins"
                        },
                        {
                            "source": "#main/scatter_gather_nchunks",
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/scatter_gather_nchunks"
                        },
                        {
                            "default": "30 2.2 2.5",
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/seg"
                        },
                        {
                            "default": "yes",
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/soft_masking"
                        },
                        {
                            "source": "#main/taxid",
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/taxid"
                        },
                        {
                            "source": "#main/taxon_db",
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/taxon_db"
                        },
                        {
                            "default": 21,
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/threshold"
                        },
                        {
                            "default": 10,
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/top_by_score"
                        },
                        {
                            "default": 6,
                            "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/word_size"
                        }
                    ],
                    "out": [
                        "#main/blastp_current_prokaryotic_proteins_vs_orthologs/blast_align"
                    ],
                    "id": "#main/blastp_current_prokaryotic_proteins_vs_orthologs"
                },
                {
                    "label": "BLASTp Current Prokaryotic Proteins vs Orthologs/cat aligns",
                    "run": "#cat.cwl",
                    "in": [
                        {
                            "source": "#main/blastp_current_prokaryotic_proteins_vs_orthologs/blast_align",
                            "id": "#main/cat_aligns/input"
                        },
                        {
                            "default": "blastp.align.asn",
                            "id": "#main/cat_aligns/output_file_name"
                        }
                    ],
                    "out": [
                        "#main/cat_aligns/output"
                    ],
                    "id": "#main/cat_aligns"
                },
                {
                    "label": "Create Orthologous Prokaryotic Protein BLASTdb",
                    "run": "#gp_makeblastdb.cwl",
                    "in": [
                        {
                            "source": "#main/asn_cache",
                            "id": "#main/create_orthologous_prokaryotic_protein_blastdb/asn_cache"
                        },
                        {
                            "source": "#main/extract_protein_references_for_orthology/proteins",
                            "id": "#main/create_orthologous_prokaryotic_protein_blastdb/asnb"
                        },
                        {
                            "default": "prot",
                            "id": "#main/create_orthologous_prokaryotic_protein_blastdb/dbtype"
                        },
                        {
                            "default": "protein database for orhology graph",
                            "id": "#main/create_orthologous_prokaryotic_protein_blastdb/title"
                        }
                    ],
                    "out": [
                        "#main/create_orthologous_prokaryotic_protein_blastdb/blastdb"
                    ],
                    "id": "#main/create_orthologous_prokaryotic_protein_blastdb"
                },
                {
                    "label": "Extract Orthologous Prokaryotic Proteins: fetch nucleotide ASN.1",
                    "run": "#gp_fetch_sequences.cwl",
                    "in": [
                        {
                            "source": "#main/asn_cache",
                            "id": "#main/extract_ortholog_nucleotide_asn/asn_cache"
                        },
                        {
                            "source": "#main/get_ortholog_nucleotide_ids/molecules",
                            "id": "#main/extract_ortholog_nucleotide_asn/input"
                        },
                        {
                            "default": "orhologous.nucleotide.asn",
                            "id": "#main/extract_ortholog_nucleotide_asn/out_asn_name"
                        }
                    ],
                    "out": [
                        "#main/extract_ortholog_nucleotide_asn/output"
                    ],
                    "id": "#main/extract_ortholog_nucleotide_asn"
                },
                {
                    "label": "Extract Orthologous Prokaryotic Proteins",
                    "run": "#protein_extract.cwl",
                    "in": [
                        {
                            "source": "#main/extract_ortholog_nucleotide_asn/output",
                            "id": "#main/extract_protein_references_for_orthology/input"
                        },
                        {
                            "default": true,
                            "id": "#main/extract_protein_references_for_orthology/nogenbank"
                        }
                    ],
                    "out": [
                        "#main/extract_protein_references_for_orthology/proteins"
                    ],
                    "id": "#main/extract_protein_references_for_orthology"
                },
                {
                    "label": "Extract Protein Targets for Orthology",
                    "run": "#protein_extract.cwl",
                    "in": [
                        {
                            "source": "#main/input",
                            "id": "#main/extract_protein_targets_for_orthology/input"
                        },
                        {
                            "default": true,
                            "id": "#main/extract_protein_targets_for_orthology/nogenbank"
                        }
                    ],
                    "out": [
                        "#main/extract_protein_targets_for_orthology/proteins",
                        "#main/extract_protein_targets_for_orthology/lds2",
                        "#main/extract_protein_targets_for_orthology/seqids"
                    ],
                    "id": "#main/extract_protein_targets_for_orthology"
                },
                {
                    "label": "Find Prokaryotic Orthologs",
                    "run": "#find_orthologs.cwl",
                    "in": [
                        {
                            "source": "#main/prepare_annotation_input/output",
                            "id": "#main/find_prokarotic_orthologs/annots1"
                        },
                        {
                            "source": "#main/asn_cache",
                            "id": "#main/find_prokarotic_orthologs/asn_cache"
                        },
                        {
                            "source": "#main/gencoll_asn",
                            "id": "#main/find_prokarotic_orthologs/gc1"
                        },
                        {
                            "source": "#main/get_assemblies_for_orthologs_gencoll_asn/gencoll_asn",
                            "id": "#main/find_prokarotic_orthologs/gc2"
                        },
                        {
                            "source": "#main/cat_aligns/output",
                            "id": "#main/find_prokarotic_orthologs/prot_hits"
                        }
                    ],
                    "out": [
                        "#main/find_prokarotic_orthologs/orthologs"
                    ],
                    "id": "#main/find_prokarotic_orthologs"
                },
                {
                    "label": "Get Assemblies for Orthologs GenColl ASN",
                    "run": "#tt_gcaccess_from_list.cwl",
                    "in": [
                        {
                            "source": "#main/gc_cache",
                            "id": "#main/get_assemblies_for_orthologs_gencoll_asn/gc_cache"
                        },
                        {
                            "source": "#main/gc_id_list_orth",
                            "id": "#main/get_assemblies_for_orthologs_gencoll_asn/gc_id_list"
                        }
                    ],
                    "out": [
                        "#main/get_assemblies_for_orthologs_gencoll_asn/gencoll_asn"
                    ],
                    "id": "#main/get_assemblies_for_orthologs_gencoll_asn"
                },
                {
                    "label": "Get Assemblies for Orthologs GenColl ASN/nucleotide ids",
                    "run": "#gc_get_molecules.cwl",
                    "in": [
                        {
                            "source": "#main/get_assemblies_for_orthologs_gencoll_asn/gencoll_asn",
                            "id": "#main/get_ortholog_nucleotide_ids/gc_assembly"
                        }
                    ],
                    "out": [
                        "#main/get_ortholog_nucleotide_ids/molecules"
                    ],
                    "id": "#main/get_ortholog_nucleotide_ids"
                },
                {
                    "label": "Prepare Annotation Input",
                    "run": "#asn_translator.cwl",
                    "in": [
                        {
                            "source": "#main/input",
                            "id": "#main/prepare_annotation_input/input"
                        },
                        {
                            "default": "input_text.asn",
                            "id": "#main/prepare_annotation_input/output_name"
                        }
                    ],
                    "out": [
                        "#main/prepare_annotation_input/output"
                    ],
                    "id": "#main/prepare_annotation_input"
                },
                {
                    "label": "Propagate symbols to genes",
                    "run": "#propagate_symbols_to_genes.cwl",
                    "in": [
                        {
                            "source": "#main/prepare_annotation_input/output",
                            "id": "#main/propagate_symbols_to_genes/input"
                        },
                        {
                            "default": true,
                            "id": "#main/propagate_symbols_to_genes/it"
                        },
                        {
                            "source": "#main/find_prokarotic_orthologs/orthologs",
                            "id": "#main/propagate_symbols_to_genes/orthologs"
                        }
                    ],
                    "out": [
                        "#main/propagate_symbols_to_genes/output"
                    ],
                    "id": "#main/propagate_symbols_to_genes"
                }
            ],
            "id": "#main",
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/propagate_symbols_to_genes/output",
                    "id": "#main/output"
                }
            ]
        },
        {
            "label": "asn_translator",
            "class": "CommandLineTool",
            "baseCommand": "asn_translator",
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-class"
                    },
                    "id": "#asn_translator.cwl/class1"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-conffile"
                    },
                    "id": "#asn_translator.cwl/conffile"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-input"
                    },
                    "id": "#asn_translator.cwl/input"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-input-manifest"
                    },
                    "id": "#asn_translator.cwl/input_manifest"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-input-mask"
                    },
                    "id": "#asn_translator.cwl/input_mask"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-input-path"
                    },
                    "id": "#asn_translator.cwl/input_path"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-items-per-chunk"
                    },
                    "id": "#asn_translator.cwl/items_per_chunk"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-len"
                    },
                    "id": "#asn_translator.cwl/len"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-logfile"
                    },
                    "id": "#asn_translator.cwl/logfile_output"
                },
                {
                    "type": [
                        "null",
                        "long"
                    ],
                    "inputBinding": {
                        "prefix": "-max-chunk-size"
                    },
                    "id": "#asn_translator.cwl/max_chunk_size"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-max-files-per-dir"
                    },
                    "id": "#asn_translator.cwl/max_files_per_dir"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-max-objects"
                    },
                    "id": "#asn_translator.cwl/max_objects"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-min-chunk-size"
                    },
                    "id": "#asn_translator.cwl/min_chunk_size"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-num-partitions"
                    },
                    "id": "#asn_translator.cwl/num_partitions"
                },
                {
                    "type": [
                        "null",
                        "long"
                    ],
                    "inputBinding": {
                        "prefix": "-offset"
                    },
                    "id": "#asn_translator.cwl/offset"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "asn_translated.asn",
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#asn_translator.cwl/output_name"
                }
            ],
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.logfile_output)"
                    },
                    "id": "#asn_translator.cwl/logfile"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "id": "#asn_translator.cwl/output"
                }
            ],
            "id": "#asn_translator.cwl"
        },
        {
            "baseCommand": "cat",
            "class": "CommandLineTool",
            "doc": "concatenates input File[] to output File",
            "stdout": "$(inputs.output_file_name)",
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#cat.cwl/input"
                },
                {
                    "type": "string",
                    "default": "concatenated.file",
                    "id": "#cat.cwl/output_file_name"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#cat.cwl/output",
                    "outputBinding": {
                        "glob": "$(inputs.output_file_name)"
                    }
                }
            ],
            "id": "#cat.cwl"
        },
        {
            "label": "cluster_blastp_wnode",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMax": 5000
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.blastdb_dir)",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=0; var s=inputs.asn_cache.length-1; var as = cs; if(as >= s) {as = s }; return inputs.asn_cache[as]; }",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=1; var s=inputs.asn_cache.length-1; var as = cs; if(as >= s) {as = s }; return inputs.asn_cache[as]; }",
                            "writable": false
                        },
                        {
                            "entry": "$(inputs.lds2)",
                            "writable": true
                        },
                        {
                            "entry": "$(inputs.proteins)",
                            "writable": false
                        }
                    ]
                }
            ],
            "baseCommand": "cluster_blastp_wnode",
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "-align_filter"
                    },
                    "id": "#cluster_blastp_wnode.cwl/align_filter"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-allow-intersection"
                    },
                    "id": "#cluster_blastp_wnode.cwl/allow_intersection"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "inputBinding": {
                        "prefix": "-asn-cache",
                        "itemSeparator": ","
                    },
                    "id": "#cluster_blastp_wnode.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-backlog"
                    },
                    "id": "#cluster_blastp_wnode.cwl/backlog"
                },
                {
                    "type": "Directory",
                    "id": "#cluster_blastp_wnode.cwl/blastdb_dir"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "-comp_based_stats"
                    },
                    "id": "#cluster_blastp_wnode.cwl/comp_based_stats"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-compart"
                    },
                    "id": "#cluster_blastp_wnode.cwl/compart"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-dbsize"
                    },
                    "id": "#cluster_blastp_wnode.cwl/dbsize"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-delay"
                    },
                    "id": "#cluster_blastp_wnode.cwl/delay"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "prefix": "-evalue"
                    },
                    "id": "#cluster_blastp_wnode.cwl/evalue"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-extra-coverage"
                    },
                    "id": "#cluster_blastp_wnode.cwl/extra_coverage"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-input-jobs"
                    },
                    "id": "#cluster_blastp_wnode.cwl/input_jobs"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-lds2"
                    },
                    "id": "#cluster_blastp_wnode.cwl/lds2"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-max-jobs"
                    },
                    "id": "#cluster_blastp_wnode.cwl/max_jobs"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-max_target_seqs"
                    },
                    "id": "#cluster_blastp_wnode.cwl/max_target_seqs"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-no-merge"
                    },
                    "id": "#cluster_blastp_wnode.cwl/no_merge"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-nogenbank"
                    },
                    "id": "#cluster_blastp_wnode.cwl/nogenbank"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-ofmt"
                    },
                    "id": "#cluster_blastp_wnode.cwl/ofmt"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "output",
                    "inputBinding": {
                        "prefix": "-O"
                    },
                    "id": "#cluster_blastp_wnode.cwl/output_dir"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#cluster_blastp_wnode.cwl/proteins"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-seg"
                    },
                    "id": "#cluster_blastp_wnode.cwl/seg"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-short-protein-threshold"
                    },
                    "id": "#cluster_blastp_wnode.cwl/short_protein_threshold"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-soft_masking"
                    },
                    "id": "#cluster_blastp_wnode.cwl/soft_masking"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-threshold"
                    },
                    "id": "#cluster_blastp_wnode.cwl/threshold"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-top-by-score"
                    },
                    "id": "#cluster_blastp_wnode.cwl/top_by_score"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "-word_size"
                    },
                    "id": "#cluster_blastp_wnode.cwl/word_size"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-workers"
                    },
                    "id": "#cluster_blastp_wnode.cwl/workers"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "prefix": "-workers-per-cpu"
                    },
                    "id": "#cluster_blastp_wnode.cwl/workers_per_cpu"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.output_dir)"
                    },
                    "id": "#cluster_blastp_wnode.cwl/outdir"
                }
            ],
            "id": "#cluster_blastp_wnode.cwl"
        },
        {
            "label": "find_orthologs",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "annots1.mft",
                            "entry": "${var blob = '# annots1.mft created for find_orthologs from input annots1 File\\n';  if(inputs.annots1 != null) { blob += inputs.annots1.path + '\\n'; } return blob; }"
                        }
                    ]
                }
            ],
            "baseCommand": "find_orthologs",
            "inputs": [
                {
                    "type": "File",
                    "id": "#find_orthologs.cwl/annots1"
                },
                {
                    "type": "string",
                    "default": "annots1.mft",
                    "inputBinding": {
                        "prefix": "-annots1"
                    },
                    "id": "#find_orthologs.cwl/annots1impl"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "inputBinding": {
                        "prefix": "-asn-cache",
                        "itemSeparator": ","
                    },
                    "id": "#find_orthologs.cwl/asn_cache"
                },
                {
                    "type": "boolean",
                    "default": true,
                    "id": "#find_orthologs.cwl/check_exome"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-gc1"
                    },
                    "id": "#find_orthologs.cwl/gc1"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-gc2"
                    },
                    "id": "#find_orthologs.cwl/gc2"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "orthologs.rpt",
                    "inputBinding": {
                        "prefix": "-o_orthologs"
                    },
                    "id": "#find_orthologs.cwl/o_orthologs"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "stats.xml",
                    "inputBinding": {
                        "prefix": "-o_stats"
                    },
                    "id": "#find_orthologs.cwl/o_stats"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-prot_hits"
                    },
                    "id": "#find_orthologs.cwl/prot_hits"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.o_orthologs)"
                    },
                    "id": "#find_orthologs.cwl/orthologs"
                }
            ],
            "id": "#find_orthologs.cwl"
        },
        {
            "label": "gc_get_assembly",
            "class": "CommandLineTool",
            "baseCommand": "gc_get_assembly",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-gc-cache"
                    },
                    "id": "#gc_get_assembly.cwl/gc_cache"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-mode"
                    },
                    "id": "#gc_get_assembly.cwl/mode"
                },
                {
                    "type": "string",
                    "default": "gencoll.asn",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#gc_get_assembly.cwl/output_name"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-release_id_list"
                    },
                    "id": "#gc_get_assembly.cwl/release_id_list"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "id": "#gc_get_assembly.cwl/gencoll_asn"
                }
            ],
            "id": "#gc_get_assembly.cwl"
        },
        {
            "label": "gc_get_molecules",
            "class": "CommandLineTool",
            "baseCommand": "gc_get_molecules",
            "arguments": [
                "-nogenbank"
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "all",
                    "inputBinding": {
                        "prefix": "-filter"
                    },
                    "id": "#gc_get_molecules.cwl/filter"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-gc-assembly"
                    },
                    "id": "#gc_get_molecules.cwl/gc_assembly"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "top-level",
                    "inputBinding": {
                        "prefix": "-level"
                    },
                    "id": "#gc_get_molecules.cwl/level"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "assembly.molecules.ids",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#gc_get_molecules.cwl/output_name"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "id": "#gc_get_molecules.cwl/molecules"
                }
            ],
            "id": "#gc_get_molecules.cwl"
        },
        {
            "label": "gp_fetch_sequences",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.proteins)",
                            "writable": false
                        }
                    ]
                }
            ],
            "baseCommand": "gp_fetch_sequences",
            "arguments": [
                "-nogenbank"
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "Directory"
                        }
                    ],
                    "inputBinding": {
                        "prefix": "-asn-cache",
                        "itemSeparator": ","
                    },
                    "id": "#gp_fetch_sequences.cwl/asn_cache"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-input"
                    },
                    "id": "#gp_fetch_sequences.cwl/input"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-lds2"
                    },
                    "id": "#gp_fetch_sequences.cwl/lds2"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "out_asn_name.asn",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#gp_fetch_sequences.cwl/out_asn_name"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gp_fetch_sequences.cwl/proteins"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.out_asn_name)"
                    },
                    "id": "#gp_fetch_sequences.cwl/output"
                }
            ],
            "id": "#gp_fetch_sequences.cwl"
        },
        {
            "label": "gp_makeblastdb",
            "class": "Workflow",
            "requirements": [
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "id": "#gp_makeblastdb.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gp_makeblastdb.cwl/asnb"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gp_makeblastdb.cwl/asnt"
                },
                {
                    "type": "string",
                    "id": "#gp_makeblastdb.cwl/dbtype"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gp_makeblastdb.cwl/fasta"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gp_makeblastdb.cwl/hardmask"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gp_makeblastdb.cwl/ids"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gp_makeblastdb.cwl/lds2"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gp_makeblastdb.cwl/molecules"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gp_makeblastdb.cwl/softmask"
                },
                {
                    "type": "string",
                    "id": "#gp_makeblastdb.cwl/title"
                }
            ],
            "steps": [
                {
                    "run": {
                        "class": "CommandLineTool",
                        "requirements": [
                            {
                                "class": "InitialWorkDirRequirement",
                                "listing": [
                                    {
                                        "entry": "$(inputs.molecules)",
                                        "writable": false
                                    }
                                ]
                            }
                        ],
                        "baseCommand": "gp_makeblastdb",
                        "arguments": [
                            "-nogenbank"
                        ],
                        "inputs": [
                            {
                                "type": {
                                    "type": "array",
                                    "items": "Directory"
                                },
                                "inputBinding": {
                                    "prefix": "-asn-cache",
                                    "itemSeparator": ","
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/asn_cache"
                            },
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "inputBinding": {
                                    "prefix": "-asnb"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/asnb"
                            },
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "inputBinding": {
                                    "prefix": "-asnt"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/asnt"
                            },
                            {
                                "type": "string",
                                "inputBinding": {
                                    "prefix": "-dbtype"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/dbtype"
                            },
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "inputBinding": {
                                    "prefix": "-fasta"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/fasta"
                            },
                            {
                                "type": "string",
                                "default": "found_ids.txt",
                                "inputBinding": {
                                    "prefix": "-found-ids-output"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/found_ids_output_file"
                            },
                            {
                                "type": "string",
                                "default": "found_ids.mft",
                                "inputBinding": {
                                    "prefix": "-found-ids-output-manifest"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/found_ids_output_manifest"
                            },
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "inputBinding": {
                                    "prefix": "-hardmask"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/hardmask"
                            },
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "inputBinding": {
                                    "prefix": "-ids"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/ids"
                            },
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "inputBinding": {
                                    "prefix": "-lds2"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/lds2"
                            },
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "id": "#gp_makeblastdb.cwl/actual/run/molecules"
                            },
                            {
                                "type": "string",
                                "default": "blastdb",
                                "inputBinding": {
                                    "prefix": "-db"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/output_db_file"
                            },
                            {
                                "type": "string",
                                "default": "blastdb.mft",
                                "inputBinding": {
                                    "prefix": "-output-manifest"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/output_db_manifest"
                            },
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "inputBinding": {
                                    "prefix": "-softmask"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/softmask"
                            },
                            {
                                "type": "string",
                                "inputBinding": {
                                    "prefix": "-title"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/title"
                            }
                        ],
                        "outputs": [
                            {
                                "type": {
                                    "type": "array",
                                    "items": "File"
                                },
                                "outputBinding": {
                                    "glob": "blastdb.*"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/blastfiles"
                            },
                            {
                                "type": "string",
                                "outputBinding": {
                                    "outputEval": "$(inputs.output_db_file)"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/dbname"
                            },
                            {
                                "type": "File",
                                "outputBinding": {
                                    "glob": "$(inputs.found_ids_output_file)"
                                },
                                "id": "#gp_makeblastdb.cwl/actual/run/found_ids"
                            }
                        ]
                    },
                    "in": [
                        {
                            "source": "#gp_makeblastdb.cwl/asn_cache",
                            "id": "#gp_makeblastdb.cwl/actual/asn_cache"
                        },
                        {
                            "source": "#gp_makeblastdb.cwl/asnb",
                            "id": "#gp_makeblastdb.cwl/actual/asnb"
                        },
                        {
                            "source": "#gp_makeblastdb.cwl/asnt",
                            "id": "#gp_makeblastdb.cwl/actual/asnt"
                        },
                        {
                            "source": "#gp_makeblastdb.cwl/dbtype",
                            "id": "#gp_makeblastdb.cwl/actual/dbtype"
                        },
                        {
                            "source": "#gp_makeblastdb.cwl/fasta",
                            "id": "#gp_makeblastdb.cwl/actual/fasta"
                        },
                        {
                            "source": "#gp_makeblastdb.cwl/hardmask",
                            "id": "#gp_makeblastdb.cwl/actual/hardmask"
                        },
                        {
                            "source": "#gp_makeblastdb.cwl/ids",
                            "id": "#gp_makeblastdb.cwl/actual/ids"
                        },
                        {
                            "source": "#gp_makeblastdb.cwl/softmask",
                            "id": "#gp_makeblastdb.cwl/actual/softmask"
                        },
                        {
                            "source": "#gp_makeblastdb.cwl/title",
                            "id": "#gp_makeblastdb.cwl/actual/title"
                        }
                    ],
                    "out": [
                        "#gp_makeblastdb.cwl/actual/blastfiles"
                    ],
                    "id": "#gp_makeblastdb.cwl/actual"
                },
                {
                    "run": {
                        "class": "CommandLineTool",
                        "requirements": [
                            {
                                "class": "ShellCommandRequirement"
                            }
                        ],
                        "arguments": [
                            {
                                "shellQuote": false,
                                "valueFrom": "mkdir $(inputs.blastdir) && cp"
                            }
                        ],
                        "inputs": [
                            {
                                "type": "string",
                                "inputBinding": {
                                    "position": 2
                                },
                                "id": "#gp_makeblastdb.cwl/mkdir/run/blastdir"
                            },
                            {
                                "type": {
                                    "type": "array",
                                    "items": "File"
                                },
                                "inputBinding": {
                                    "position": 1
                                },
                                "id": "#gp_makeblastdb.cwl/mkdir/run/blastfiles"
                            }
                        ],
                        "outputs": [
                            {
                                "type": "Directory",
                                "outputBinding": {
                                    "glob": "$(inputs.blastdir)"
                                },
                                "id": "#gp_makeblastdb.cwl/mkdir/run/blastdb"
                            }
                        ]
                    },
                    "in": [
                        {
                            "default": "blastdir",
                            "id": "#gp_makeblastdb.cwl/mkdir/blastdir"
                        },
                        {
                            "source": "#gp_makeblastdb.cwl/actual/blastfiles",
                            "id": "#gp_makeblastdb.cwl/mkdir/blastfiles"
                        }
                    ],
                    "out": [
                        "#gp_makeblastdb.cwl/mkdir/blastdb"
                    ],
                    "id": "#gp_makeblastdb.cwl/mkdir"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputSource": "#gp_makeblastdb.cwl/mkdir/blastdb",
                    "id": "#gp_makeblastdb.cwl/blastdb"
                }
            ],
            "id": "#gp_makeblastdb.cwl"
        },
        {
            "label": "gpx_qdump",
            "class": "CommandLineTool",
            "arguments": [
                "-produce-empty-file"
            ],
            "baseCommand": "gpx_qdump",
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-input-path"
                    },
                    "id": "#gpx_qdump.cwl/input_path"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "output.asn",
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#gpx_qdump.cwl/output_name"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-unzip"
                    },
                    "id": "#gpx_qdump.cwl/unzip"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "id": "#gpx_qdump.cwl/output"
                }
            ],
            "id": "#gpx_qdump.cwl"
        },
        {
            "label": "gpx_qsubmit",
            "doc": "This workflow is specialized for the case when there is an LDS2 input  LDS2 is a _reference_ object, the kind that CWL does not like we need to provide actual input: proteins which matches the name of ASN.1 object references in LDS2 Another limitation is that it can handle no more than two item arrays in blastdb_dir and asn_cache Workaround used so far: in:\n  proteins:\n    default:\n        class: File\n        path: '/dev/null'\n        basename: 'null'\n        contents: ''\n",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.proteins)",
                            "writable": false
                        },
                        {
                            "entry": "$(inputs.blastdb_dir)",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=0; var s=inputs.asn_cache.length-1; var as = cs; if(as >= s) {as = s }; return inputs.asn_cache[as]; }",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=1; var s=inputs.asn_cache.length-1; var as = cs; if(as >= s) {as = s }; return inputs.asn_cache[as]; }",
                            "writable": false
                        },
                        {
                            "entryname": "ids.mft",
                            "entry": "${var blob = '# ids.mft created for gpx_qsubmit from input ids Array of Files\\n';for (var i = 0; i < inputs.ids.length; i++) {blob += inputs.ids[i].path  + '\\n';}return blob;}"
                        }
                    ]
                }
            ],
            "baseCommand": "gpx_qsubmit",
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-NxM-threshold"
                    },
                    "id": "#gpx_qsubmit.cwl/NxM_threshold"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "subject",
                    "inputBinding": {
                        "prefix": "-affinity"
                    },
                    "id": "#gpx_qsubmit.cwl/affinity"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "Directory"
                        }
                    ],
                    "inputBinding": {
                        "prefix": "-asn-cache",
                        "itemSeparator": ","
                    },
                    "id": "#gpx_qsubmit.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-batch-size"
                    },
                    "id": "#gpx_qsubmit.cwl/batch_size"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "prefix": "-db",
                        "valueFrom": "${ var blob = ''; for (var i = 0; i < inputs.blastdb.length; i++) { blob += inputs.blastdb_dir.path + '/' + inputs.blastdb[i]; if(i != inputs.blastdb.length-1) blob += ','; } return blob; }"
                    },
                    "id": "#gpx_qsubmit.cwl/blastdb"
                },
                {
                    "type": [
                        "null",
                        "Directory"
                    ],
                    "id": "#gpx_qsubmit.cwl/blastdb_dir"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "id": "#gpx_qsubmit.cwl/ids"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "ids.mft",
                    "inputBinding": {
                        "prefix": "-ids-manifest"
                    },
                    "id": "#gpx_qsubmit.cwl/ids_manifest"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-lds2"
                    },
                    "id": "#gpx_qsubmit.cwl/lds2"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-max-batch-length"
                    },
                    "id": "#gpx_qsubmit.cwl/max_batch_length"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": true,
                    "inputBinding": {
                        "prefix": "-nogenbank"
                    },
                    "id": "#gpx_qsubmit.cwl/nogenbank"
                },
                {
                    "type": "string",
                    "default": "jobs.xml",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#gpx_qsubmit.cwl/output_xml_jobs"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-overlap"
                    },
                    "id": "#gpx_qsubmit.cwl/overlap"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#gpx_qsubmit.cwl/proteins"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-queries-gc-id-list"
                    },
                    "id": "#gpx_qsubmit.cwl/queries_gc_id_list"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-subjects-gc-id-list"
                    },
                    "id": "#gpx_qsubmit.cwl/subjects_gc_id_list"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-subseq-size"
                    },
                    "id": "#gpx_qsubmit.cwl/subseq_size"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-xml-jobs"
                    },
                    "id": "#gpx_qsubmit.cwl/xml_jobs"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_xml_jobs)"
                    },
                    "id": "#gpx_qsubmit.cwl/jobs"
                }
            ],
            "id": "#gpx_qsubmit.cwl"
        },
        {
            "label": "orf_hits_cache_retrieve",
            "class": "CommandLineTool",
            "baseCommand": "orf_hits_cache_retrieve",
            "arguments": [
                "-nogenbank"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.proteins)",
                            "writable": false
                        },
                        {
                            "entryname": "ids.mft",
                            "entry": "${\n  var blob = '# ids.mft created for orf_hits_cache_retrieve from input \"orfs\" Array of Files' +\n    String.fromCharCode(10) ; \n  for (var i = 0; i < inputs.orfs.length; i++) { \n    blob += inputs.orfs[i].path + String.fromCharCode(10); \n  } \n  return blob; \n}"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-blast-type"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/blast_type"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "int"
                        }
                    ],
                    "inputBinding": {
                        "prefix": "-genus-list",
                        "itemSeparator": ","
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/genus_list"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "retrieved_hits.asn",
                    "inputBinding": {
                        "prefix": "-hits-output"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/hits_output_name"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-lds2"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/lds2"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "not_found.ids",
                    "inputBinding": {
                        "prefix": "-not-found-output"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/not_found_output_name"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/orfs"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "ids.mft",
                    "inputBinding": {
                        "prefix": "-orfs-manifest"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/orfs_manifest"
                },
                {
                    "type": "File",
                    "id": "#orf_hits_cache_retrieve.cwl/proteins"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-blast-hits-sqlite-cache"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/sqlite_cache"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-taxid"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/taxid"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-taxon-db"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/taxon_db"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.hits_output_name)"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/hits_output"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.not_found_output_name)"
                    },
                    "id": "#orf_hits_cache_retrieve.cwl/not_found_output"
                }
            ],
            "id": "#orf_hits_cache_retrieve.cwl"
        },
        {
            "label": "propagate_symbols_to_genes",
            "class": "CommandLineTool",
            "baseCommand": "propagate_symbols_to_genes",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-input"
                    },
                    "id": "#propagate_symbols_to_genes.cwl/input"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "prefix": "-it"
                    },
                    "id": "#propagate_symbols_to_genes.cwl/it"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-orthologs"
                    },
                    "id": "#propagate_symbols_to_genes.cwl/orthologs"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "propagated_gene_symbols_annot.asn",
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#propagate_symbols_to_genes.cwl/output_name"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0.8,
                    "inputBinding": {
                        "prefix": "-prot_similarity_threshold"
                    },
                    "id": "#propagate_symbols_to_genes.cwl/prot_similarity_threshold"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0.9,
                    "inputBinding": {
                        "prefix": "-q_coverage_threshold"
                    },
                    "id": "#propagate_symbols_to_genes.cwl/q_coverage_threshold"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "default": 0.9,
                    "inputBinding": {
                        "prefix": "-s_coverage_threshold"
                    },
                    "id": "#propagate_symbols_to_genes.cwl/s_coverage_threshold"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "id": "#propagate_symbols_to_genes.cwl/output"
                }
            ],
            "id": "#propagate_symbols_to_genes.cwl"
        },
        {
            "label": "protein_extract",
            "class": "Workflow",
            "inputs": [
                {
                    "type": "File",
                    "id": "#protein_extract.cwl/input"
                },
                {
                    "type": "boolean",
                    "id": "#protein_extract.cwl/nogenbank"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#protein_extract.cwl/olds2"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#protein_extract.cwl/oproteins"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#protein_extract.cwl/oseqids"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#protein_extract.cwl/lds2_fix/lds2",
                    "id": "#protein_extract.cwl/lds2"
                },
                {
                    "type": "File",
                    "outputSource": "#protein_extract.cwl/protein_extract/proteins",
                    "id": "#protein_extract.cwl/proteins"
                },
                {
                    "type": "File",
                    "outputSource": "#protein_extract.cwl/protein_extract/seqids",
                    "id": "#protein_extract.cwl/seqids"
                }
            ],
            "steps": [
                {
                    "in": [
                        {
                            "source": "#protein_extract.cwl/protein_extract/lds2",
                            "id": "#protein_extract.cwl/lds2_fix/in_lds2"
                        }
                    ],
                    "out": [
                        "#protein_extract.cwl/lds2_fix/lds2"
                    ],
                    "run": {
                        "class": "CommandLineTool",
                        "requirements": [
                            {
                                "listing": [
                                    {
                                        "entry": "$(inputs.in_lds2)",
                                        "writable": true
                                    }
                                ],
                                "class": "InitialWorkDirRequirement"
                            }
                        ],
                        "baseCommand": "sqlite3",
                        "inputs": [
                            {
                                "type": "File",
                                "inputBinding": {
                                    "position": 1
                                },
                                "id": "#protein_extract.cwl/lds2_fix/run/in_lds2"
                            },
                            {
                                "type": [
                                    "null",
                                    "string"
                                ],
                                "default": "update file set file_name=replace(file_name, rtrim(file_name, replace(file_name, '/', '')), '');",
                                "inputBinding": {
                                    "position": 2
                                },
                                "id": "#protein_extract.cwl/lds2_fix/run/sql"
                            }
                        ],
                        "outputs": [
                            {
                                "type": "File",
                                "outputBinding": {
                                    "glob": "$(inputs.in_lds2.basename)"
                                },
                                "id": "#protein_extract.cwl/lds2_fix/run/lds2"
                            }
                        ]
                    },
                    "id": "#protein_extract.cwl/lds2_fix"
                },
                {
                    "in": [
                        {
                            "source": "#protein_extract.cwl/input",
                            "id": "#protein_extract.cwl/protein_extract/input"
                        },
                        {
                            "source": "#protein_extract.cwl/nogenbank",
                            "id": "#protein_extract.cwl/protein_extract/nogenbank"
                        },
                        {
                            "source": "#protein_extract.cwl/olds2",
                            "id": "#protein_extract.cwl/protein_extract/olds2"
                        },
                        {
                            "source": "#protein_extract.cwl/oproteins",
                            "id": "#protein_extract.cwl/protein_extract/oproteins"
                        },
                        {
                            "source": "#protein_extract.cwl/oseqids",
                            "id": "#protein_extract.cwl/protein_extract/oseqids"
                        }
                    ],
                    "out": [
                        "#protein_extract.cwl/protein_extract/proteins",
                        "#protein_extract.cwl/protein_extract/lds2",
                        "#protein_extract.cwl/protein_extract/seqids"
                    ],
                    "run": {
                        "class": "CommandLineTool",
                        "baseCommand": "protein_extract",
                        "inputs": [
                            {
                                "type": "File",
                                "inputBinding": {
                                    "prefix": "-input"
                                },
                                "id": "#protein_extract.cwl/protein_extract/run/input"
                            },
                            {
                                "type": "boolean",
                                "inputBinding": {
                                    "prefix": "-nogenbank"
                                },
                                "id": "#protein_extract.cwl/protein_extract/run/nogenbank"
                            },
                            {
                                "type": [
                                    "null",
                                    "string"
                                ],
                                "default": "LDS2",
                                "inputBinding": {
                                    "prefix": "-olds2"
                                },
                                "id": "#protein_extract.cwl/protein_extract/run/olds2"
                            },
                            {
                                "type": [
                                    "null",
                                    "string"
                                ],
                                "default": "proteins.asn",
                                "inputBinding": {
                                    "prefix": "-o"
                                },
                                "id": "#protein_extract.cwl/protein_extract/run/oproteins"
                            },
                            {
                                "type": [
                                    "null",
                                    "string"
                                ],
                                "default": "proteins.seq_ids",
                                "inputBinding": {
                                    "prefix": "-oseqids"
                                },
                                "id": "#protein_extract.cwl/protein_extract/run/oseqids"
                            }
                        ],
                        "outputs": [
                            {
                                "type": "File",
                                "outputBinding": {
                                    "glob": "$(inputs.olds2)"
                                },
                                "id": "#protein_extract.cwl/protein_extract/run/lds2"
                            },
                            {
                                "type": "File",
                                "outputBinding": {
                                    "glob": "$(inputs.oproteins)"
                                },
                                "id": "#protein_extract.cwl/protein_extract/run/proteins"
                            },
                            {
                                "type": "File",
                                "outputBinding": {
                                    "glob": "$(inputs.oseqids)"
                                },
                                "id": "#protein_extract.cwl/protein_extract/run/seqids"
                            }
                        ]
                    },
                    "id": "#protein_extract.cwl/protein_extract"
                }
            ],
            "id": "#protein_extract.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "file concatenation",
            "baseCommand": "cat",
            "stdout": "cat.out",
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#cat_array_of_files.cwl/files_in"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#cat_array_of_files.cwl/file_out",
                    "outputBinding": {
                        "glob": "cat.out"
                    }
                }
            ],
            "id": "#cat_array_of_files.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "cwl split wrapper",
            "baseCommand": "split",
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-l"
                    },
                    "id": "#split.cwl/chunk_size"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#split.cwl/input"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "jobs",
                    "inputBinding": {
                        "position": 5,
                        "valueFrom": "$(inputs.mask)"
                    },
                    "id": "#split.cwl/mask"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-n l//",
                        "separate": false
                    },
                    "id": "#split.cwl/nchunks"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": ".xml",
                    "inputBinding": {
                        "position": 3,
                        "separate": false,
                        "prefix": "--additional-suffix="
                    },
                    "id": "#split.cwl/suffix"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "$(inputs.mask)?*$(inputs.suffix)"
                    },
                    "id": "#split.cwl/jobs"
                }
            ],
            "id": "#split.cwl"
        },
        {
            "label": "blastp_wnode_naming",
            "class": "Workflow",
            "requirements": [
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#tt_blastp_wnode_naming.cwl/affinity"
                },
                {
                    "type": "string",
                    "id": "#tt_blastp_wnode_naming.cwl/align_filter"
                },
                {
                    "type": "boolean",
                    "id": "#tt_blastp_wnode_naming.cwl/allow_intersection"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "id": "#tt_blastp_wnode_naming.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#tt_blastp_wnode_naming.cwl/batch-size"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#tt_blastp_wnode_naming.cwl/blast_hits_cache"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#tt_blastp_wnode_naming.cwl/blast_type"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#tt_blastp_wnode_naming.cwl/blastdb"
                },
                {
                    "type": "Directory",
                    "id": "#tt_blastp_wnode_naming.cwl/blastdb_dir"
                },
                {
                    "type": "string",
                    "id": "#tt_blastp_wnode_naming.cwl/comp_based_stats"
                },
                {
                    "type": "boolean",
                    "id": "#tt_blastp_wnode_naming.cwl/compart"
                },
                {
                    "type": "string",
                    "id": "#tt_blastp_wnode_naming.cwl/dbsize"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "id": "#tt_blastp_wnode_naming.cwl/evalue"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#tt_blastp_wnode_naming.cwl/extra_coverage"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "int"
                    },
                    "id": "#tt_blastp_wnode_naming.cwl/genus_list"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#tt_blastp_wnode_naming.cwl/ids"
                },
                {
                    "type": "File",
                    "id": "#tt_blastp_wnode_naming.cwl/lds2"
                },
                {
                    "type": "int",
                    "id": "#tt_blastp_wnode_naming.cwl/max_batch_length"
                },
                {
                    "type": "int",
                    "id": "#tt_blastp_wnode_naming.cwl/max_jobs"
                },
                {
                    "type": "int",
                    "id": "#tt_blastp_wnode_naming.cwl/max_target_seqs"
                },
                {
                    "type": "boolean",
                    "id": "#tt_blastp_wnode_naming.cwl/no_merge"
                },
                {
                    "type": "boolean",
                    "id": "#tt_blastp_wnode_naming.cwl/nogenbank"
                },
                {
                    "type": "string",
                    "id": "#tt_blastp_wnode_naming.cwl/ofmt"
                },
                {
                    "type": "File",
                    "id": "#tt_blastp_wnode_naming.cwl/proteins"
                },
                {
                    "type": "string",
                    "id": "#tt_blastp_wnode_naming.cwl/scatter_gather_nchunks"
                },
                {
                    "type": "string",
                    "id": "#tt_blastp_wnode_naming.cwl/seg"
                },
                {
                    "type": "string",
                    "id": "#tt_blastp_wnode_naming.cwl/soft_masking"
                },
                {
                    "type": "int",
                    "id": "#tt_blastp_wnode_naming.cwl/taxid"
                },
                {
                    "type": "File",
                    "id": "#tt_blastp_wnode_naming.cwl/taxon_db"
                },
                {
                    "type": "int",
                    "id": "#tt_blastp_wnode_naming.cwl/threshold"
                },
                {
                    "type": "int",
                    "id": "#tt_blastp_wnode_naming.cwl/top_by_score"
                },
                {
                    "type": "int",
                    "id": "#tt_blastp_wnode_naming.cwl/word_size"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": [
                        "#tt_blastp_wnode_naming.cwl/collect_aligns/file_out",
                        "#tt_blastp_wnode_naming.cwl/retrieve_cached_hits/hits_output"
                    ],
                    "id": "#tt_blastp_wnode_naming.cwl/blast_align"
                }
            ],
            "steps": [
                {
                    "run": "#tt_cluster_and_qdump.cwl",
                    "scatter": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/input_jobs",
                    "in": [
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/align_filter",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/align_filter"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/allow_intersection",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/allow_intersection"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/asn_cache",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/asn_cache"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/blastdb_dir",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/blastdb_dir"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/comp_based_stats",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/comp_based_stats"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/compart",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/compart"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/dbsize",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/dbsize"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/evalue",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/evalue"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/extra_coverage",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/extra_coverage"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/split_jobs/jobs",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/input_jobs"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/lds2",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/lds2"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/max_jobs",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/max_jobs"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/max_target_seqs",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/max_target_seqs"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/no_merge",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/no_merge"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/nogenbank",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/nogenbank"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/ofmt",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/ofmt"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/proteins",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/proteins"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/seg",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/seg"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/soft_masking",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/soft_masking"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/threshold",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/threshold"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/top_by_score",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/top_by_score"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/word_size",
                            "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/word_size"
                        }
                    ],
                    "out": [
                        "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/blast_align"
                    ],
                    "id": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump"
                },
                {
                    "run": "#cat_array_of_files.cwl",
                    "in": [
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/cluster_and_qdump/blast_align",
                            "id": "#tt_blastp_wnode_naming.cwl/collect_aligns/files_in"
                        }
                    ],
                    "out": [
                        "#tt_blastp_wnode_naming.cwl/collect_aligns/file_out"
                    ],
                    "id": "#tt_blastp_wnode_naming.cwl/collect_aligns"
                },
                {
                    "run": "#gpx_qsubmit.cwl",
                    "in": [
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/affinity",
                            "id": "#tt_blastp_wnode_naming.cwl/gpx_qsubmit/affinity"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/asn_cache",
                            "id": "#tt_blastp_wnode_naming.cwl/gpx_qsubmit/asn_cache"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/batch-size",
                            "id": "#tt_blastp_wnode_naming.cwl/gpx_qsubmit/batch_size"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/blastdb",
                            "id": "#tt_blastp_wnode_naming.cwl/gpx_qsubmit/blastdb"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/blastdb_dir",
                            "id": "#tt_blastp_wnode_naming.cwl/gpx_qsubmit/blastdb_dir"
                        },
                        {
                            "source": [
                                "#tt_blastp_wnode_naming.cwl/retrieve_cached_hits/not_found_output"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#tt_blastp_wnode_naming.cwl/gpx_qsubmit/ids"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/lds2",
                            "id": "#tt_blastp_wnode_naming.cwl/gpx_qsubmit/lds2"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/max_batch_length",
                            "id": "#tt_blastp_wnode_naming.cwl/gpx_qsubmit/max_batch_length"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/nogenbank",
                            "id": "#tt_blastp_wnode_naming.cwl/gpx_qsubmit/nogenbank"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/proteins",
                            "id": "#tt_blastp_wnode_naming.cwl/gpx_qsubmit/proteins"
                        }
                    ],
                    "out": [
                        "#tt_blastp_wnode_naming.cwl/gpx_qsubmit/jobs"
                    ],
                    "id": "#tt_blastp_wnode_naming.cwl/gpx_qsubmit"
                },
                {
                    "run": "#orf_hits_cache_retrieve.cwl",
                    "in": [
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/blast_type",
                            "id": "#tt_blastp_wnode_naming.cwl/retrieve_cached_hits/blast_type"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/genus_list",
                            "id": "#tt_blastp_wnode_naming.cwl/retrieve_cached_hits/genus_list"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/lds2",
                            "id": "#tt_blastp_wnode_naming.cwl/retrieve_cached_hits/lds2"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/ids",
                            "id": "#tt_blastp_wnode_naming.cwl/retrieve_cached_hits/orfs"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/proteins",
                            "id": "#tt_blastp_wnode_naming.cwl/retrieve_cached_hits/proteins"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/blast_hits_cache",
                            "id": "#tt_blastp_wnode_naming.cwl/retrieve_cached_hits/sqlite_cache"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/taxid",
                            "id": "#tt_blastp_wnode_naming.cwl/retrieve_cached_hits/taxid"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/taxon_db",
                            "id": "#tt_blastp_wnode_naming.cwl/retrieve_cached_hits/taxon_db"
                        }
                    ],
                    "out": [
                        "#tt_blastp_wnode_naming.cwl/retrieve_cached_hits/hits_output",
                        "#tt_blastp_wnode_naming.cwl/retrieve_cached_hits/not_found_output"
                    ],
                    "id": "#tt_blastp_wnode_naming.cwl/retrieve_cached_hits"
                },
                {
                    "run": "#split.cwl",
                    "in": [
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/gpx_qsubmit/jobs",
                            "id": "#tt_blastp_wnode_naming.cwl/split_jobs/input"
                        },
                        {
                            "source": "#tt_blastp_wnode_naming.cwl/scatter_gather_nchunks",
                            "id": "#tt_blastp_wnode_naming.cwl/split_jobs/nchunks"
                        }
                    ],
                    "out": [
                        "#tt_blastp_wnode_naming.cwl/split_jobs/jobs"
                    ],
                    "id": "#tt_blastp_wnode_naming.cwl/split_jobs"
                }
            ],
            "id": "#tt_blastp_wnode_naming.cwl"
        },
        {
            "class": "Workflow",
            "label": "cluster_blastp_wnode and gpx_qdump combined",
            "requirements": [
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#tt_cluster_and_qdump.cwl/align_filter"
                },
                {
                    "type": "boolean",
                    "id": "#tt_cluster_and_qdump.cwl/allow_intersection"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "id": "#tt_cluster_and_qdump.cwl/asn_cache"
                },
                {
                    "type": "Directory",
                    "id": "#tt_cluster_and_qdump.cwl/blastdb_dir"
                },
                {
                    "type": "string",
                    "id": "#tt_cluster_and_qdump.cwl/comp_based_stats"
                },
                {
                    "type": "boolean",
                    "id": "#tt_cluster_and_qdump.cwl/compart"
                },
                {
                    "type": "string",
                    "id": "#tt_cluster_and_qdump.cwl/dbsize"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "id": "#tt_cluster_and_qdump.cwl/evalue"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#tt_cluster_and_qdump.cwl/extra_coverage"
                },
                {
                    "type": "File",
                    "id": "#tt_cluster_and_qdump.cwl/input_jobs"
                },
                {
                    "type": "File",
                    "id": "#tt_cluster_and_qdump.cwl/lds2"
                },
                {
                    "type": "int",
                    "id": "#tt_cluster_and_qdump.cwl/max_jobs"
                },
                {
                    "type": "int",
                    "id": "#tt_cluster_and_qdump.cwl/max_target_seqs"
                },
                {
                    "type": "boolean",
                    "id": "#tt_cluster_and_qdump.cwl/no_merge"
                },
                {
                    "type": "boolean",
                    "id": "#tt_cluster_and_qdump.cwl/nogenbank"
                },
                {
                    "type": "string",
                    "id": "#tt_cluster_and_qdump.cwl/ofmt"
                },
                {
                    "type": "File",
                    "id": "#tt_cluster_and_qdump.cwl/proteins"
                },
                {
                    "type": "string",
                    "id": "#tt_cluster_and_qdump.cwl/seg"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#tt_cluster_and_qdump.cwl/short_protein_threshold"
                },
                {
                    "type": "string",
                    "id": "#tt_cluster_and_qdump.cwl/soft_masking"
                },
                {
                    "type": "int",
                    "id": "#tt_cluster_and_qdump.cwl/threshold"
                },
                {
                    "type": "int",
                    "id": "#tt_cluster_and_qdump.cwl/top_by_score"
                },
                {
                    "type": "int",
                    "id": "#tt_cluster_and_qdump.cwl/word_size"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#tt_cluster_and_qdump.cwl/gpx_qdump/output",
                    "id": "#tt_cluster_and_qdump.cwl/blast_align"
                }
            ],
            "steps": [
                {
                    "run": "#cluster_blastp_wnode.cwl",
                    "in": [
                        {
                            "source": "#tt_cluster_and_qdump.cwl/align_filter",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/align_filter"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/allow_intersection",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/allow_intersection"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/asn_cache",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/asn_cache"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/blastdb_dir",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/blastdb_dir"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/comp_based_stats",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/comp_based_stats"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/compart",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/compart"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/dbsize",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/dbsize"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/evalue",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/evalue"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/extra_coverage",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/extra_coverage"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/input_jobs",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/input_jobs"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/lds2",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/lds2"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/max_jobs",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/max_jobs"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/max_target_seqs",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/max_target_seqs"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/no_merge",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/no_merge"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/nogenbank",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/nogenbank"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/ofmt",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/ofmt"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/proteins",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/proteins"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/seg",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/seg"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/short_protein_threshold",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/short_protein_threshold"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/soft_masking",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/soft_masking"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/threshold",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/threshold"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/top_by_score",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/top_by_score"
                        },
                        {
                            "source": "#tt_cluster_and_qdump.cwl/word_size",
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/word_size"
                        },
                        {
                            "default": 1.0,
                            "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/workers_per_cpu"
                        }
                    ],
                    "out": [
                        "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/outdir"
                    ],
                    "id": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode"
                },
                {
                    "run": "#gpx_qdump.cwl",
                    "in": [
                        {
                            "source": "#tt_cluster_and_qdump.cwl/cluster_blastp_wnode/outdir",
                            "id": "#tt_cluster_and_qdump.cwl/gpx_qdump/input_path"
                        },
                        {
                            "default": "*",
                            "id": "#tt_cluster_and_qdump.cwl/gpx_qdump/unzip"
                        }
                    ],
                    "out": [
                        "#tt_cluster_and_qdump.cwl/gpx_qdump/output"
                    ],
                    "id": "#tt_cluster_and_qdump.cwl/gpx_qdump"
                }
            ],
            "id": "#tt_cluster_and_qdump.cwl"
        },
        {
            "label": "gcaccess_from_list",
            "class": "Workflow",
            "inputs": [
                {
                    "type": "File",
                    "id": "#tt_gcaccess_from_list.cwl/gc_cache"
                },
                {
                    "type": "File",
                    "id": "#tt_gcaccess_from_list.cwl/gc_id_list"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#tt_gcaccess_from_list.cwl/gc_get_assembly/gencoll_asn",
                    "id": "#tt_gcaccess_from_list.cwl/gencoll_asn"
                }
            ],
            "steps": [
                {
                    "run": "#gc_get_assembly.cwl",
                    "in": [
                        {
                            "source": "#tt_gcaccess_from_list.cwl/gc_cache",
                            "id": "#tt_gcaccess_from_list.cwl/gc_get_assembly/gc_cache"
                        },
                        {
                            "default": "AllSequences",
                            "id": "#tt_gcaccess_from_list.cwl/gc_get_assembly/mode"
                        },
                        {
                            "source": "#tt_gcaccess_from_list.cwl/gc_id_list",
                            "id": "#tt_gcaccess_from_list.cwl/gc_get_assembly/release_id_list"
                        }
                    ],
                    "out": [
                        "#tt_gcaccess_from_list.cwl/gc_get_assembly/gencoll_asn"
                    ],
                    "id": "#tt_gcaccess_from_list.cwl/gc_get_assembly"
                }
            ],
            "id": "#tt_gcaccess_from_list.cwl"
        }
    ],
    "cwlVersion": "v1.2"
}
